#!/usr/bin/python
#-*-coding:utf-8-*-
"""
    Script d'ajout d'utilisateur dans la base Posh
"""
import getopt, sys
from posh.api.user_api import PoshUserApi
DOC = """
Usage : add_user.py [OPTION]
Ajoute un utilisateur dans l'application Envole

Obligatoires:
-u,  --user   : Le login de l'utilisateur à rajouter dans la base

Optionnels:
-f,  --fullname   : Nom long de l'utilisateur (utilisé dans l'interface)
-l,  --lang       : Langue par défaut de l'utilisateur

Ex :
1) add_user.py -u jean.dupond -l "en" -f "Jean Dupond"
rajoute jean.dupond dans la base portail

2) add_user.py -u jean.dupont
rajoute jean.dupont dans la base du portail
"""

def usage():
    """
        print la doc
    """
    print DOC

def main():
    """
        lance la commande
    """
    try:
        opts, args = getopt.getopt(sys.argv[1:], "u:f:l:h",
 ["user", "fullname", "lang", "help"])
    except getopt.GetoptError, err:
        print str(err)
        usage()
        sys.exit(2)
    user = None
    longname = None
    lang = None
    for option, value in opts:
        if option in ("-h", "--help"):
            usage()
            sys.exit(0)
        elif option in ("-u", "--user"):
            user = value
        elif option in ("-f", "--fullname"):
            longname = value
        elif option in ("-l", "--lang"):
            lang = value
        else:
            usage()
            assert False, "unhandled option"
    if user == None:
        print " - USERNAME IS MISSING -"
        usage()
        sys.exit(2)
    elif longname == None:
        longname = user
    user_api = PoshUserApi()
    if lang:
        user_api.add_user(user, longname, lang=lang)
    else:
        user_api.add_user(user, longname)
    sys.exit(0)

if __name__ == "__main__":
    main()
