#!/usr/bin/python
#-*-coding:utf-8-*-
"""
    Script d'ajout de groupe dans la base Posh
"""
import getopt, sys
from posh.api.thumb_api import PoshThumbApi
DOC = """
Usage : add_webpage.py [OPTION]
Ajoute une page web à un groupe donné

Obligatoires:
-g, --group       : Groupe auxquel ajouter la page
-p, --page        : Nom de l'onglet
-u, --url         : Url de l'onglet

Optionnels:
-d, --description : Description de l'onglet (utilisé dans l'interface)
-r, --removable  : L'onglet est supprimable par les utilisateurs
-n, --newusers    : Seulement pour les nouveaux utilisateurs

Ex:
add_webpage.py -g groupe1 -p recherche -u "http://www.yahoo.fr"
"""

def usage():
    """
        print la doc
    """
    print DOC

def main():
    """
        lance la commande
    """
    try:
        opts, args = getopt.getopt(sys.argv[1:], "g:p:u:d:h:r:n",
 ["group", "page", "url", "description", "help", 'removable', 'newusers'])
    except getopt.GetoptError, err:
        print str(err)
        usage()
        sys.exit(2)
    group = None
    url = None
    page = None
    description = None
    removable = False
    newusers = '2' # valeur par defaut (tous les users du groupe)
    for option, value in opts:
        if option in ("-h", "--help"):
            usage()
            sys.exit(0)
        elif option in ("-g", "--group"):
            group = value
        elif option in ('-p', '--page'):
            page = value
        elif option in ('-u', '--url'):
            url = value
        elif option in ('-d', '--description'):
            description = description
        elif option in ('-r', '--removable'):
            removable = True
        elif option in ('-n', '--newusers'):
            newusers = '1'
        else:
            usage()
            assert False, "unhandled option"
    if not group:
        print " - MISSING GROUPNAME -"
        usage()
        sys.exit(2)
    elif not page:
        print " - MISSING PAGENAME -"
        usage()
        sys.exit(2)
    elif not url:
        print " - MISSING PAGE'S URL -"
        usage()
        sys.exit(2)
    elif not description:
        description = page
    thumbapi = PoshThumbApi()
    thumbapi.add_webpage(group, page, url, description,
                                removable=removable, imposer=newusers)
    sys.exit(0)

if __name__ == '__main__':
    main()
