#!/usr/bin/python
#-*-coding:utf-8-*-
"""
    Script d'inscription d'un utilisateur à un groupe
"""
import getopt, sys
from posh.api.user_api import PoshUserApi
DOC = """
Usage : inscription.py -u username -g groupname
Inscrit un utilisateur à un groupe

-g,  --group      : Le nom du groupe dans lequel inscrire l'utilisateur
-u,  --user   : Le nom de l'utilisateur à inscrire

Ex:
inscription.py -u jean.dupond -g groupe1
"""

def usage():
    """
        la doc
    """
    print DOC

def main():
    """
        lance la commande
    """
    try:
        opts, args = getopt.getopt(sys.argv[1:], "g:u:h", ["group", "user", "help"])
    except getopt.GetoptError, err:
        print str(err)
        usage()
        sys.exit(2)
    user = None
    group = None
    for option, value in opts:
        if option in ("-h", "--help"):
            usage()
            sys.exit(0)
        elif option in ("-g", "--group"):
            group = value
        elif option in ("-u", "--user"):
            user = value
        else:
            usage()
            assert False, "unhandled option"
    if not group or not user:
        print " - MISSING REQUIRED ARGUMENT -"
        usage()
        sys.exit(2)
    userapi = PoshUserApi()
    userapi.subscribe_profilgroups(user, group)
    sys.exit(0)

if __name__ == "__main__":
    main()
