#-*-coding:utf-8-*-
###########################################################################
# Eole NG - 2007
# Copyright Pole de Competence Eole  (Ministere Education - Academie Dijon)
# Licence CeCill  cf /root/LicenceEole.txt
# eole@ac-dijon.fr
#
# collect_key.py
#
# Collecte la clé d'authentification de l'api Pos
#
###########################################################################
"""
    Récupère la clé d'authentification pour accéder à l'API Posh
"""
from os.path import isfile

from posh.config.api import POSH_CONFIG_FILEPATH
from posh.logger.logger import getLogger
from posh.error import MissingFile

log = getLogger("api.collect_key")

def get_posh_backend_key():
    """
        Récupère la clé d'authentification pour accéder à l'API Posh
        parse la ligne :
            define(__KEY,"<la clé>");
    """
    key = "0123456789"
    if isfile(POSH_CONFIG_FILEPATH): # parsing du fichier de configuration
        conf = file(POSH_CONFIG_FILEPATH, 'r').read().splitlines()
        for line in conf:
            if line.startswith('define("__KEY","'):
                key = line.split('"')[3].strip()
                break
        return key
    else:
        log.error("Il manque le fichier de configuration %s , un \
reconfigure a-t-il bien été éxécuté ?" % POSH_CONFIG_FILEPATH)
        raise MissingFile("Il manque le fichier de configuration %s , un \
reconfigure a-t-il bien été éxécuté ?" % POSH_CONFIG_FILEPATH)
    return key
