#-*-coding:utf-8-*-
from os.path import join, dirname, normpath
from posh.config.loader import ConfigurationObject

HERE = dirname(__file__)
LOCAL_DIR = normpath(join(HERE, '..'))
# Path vers les scripts du module posh
SCRIPT_PATH = '/usr/share/xmlrpc-posh'

# Permissions :
# Configuration en mode fichier
# Fichier de permission: lie les onglets à des profiles
perm_filename = join(LOCAL_DIR, 'perm', 'data', 'perm.ini')
# Fichier de profile : lie des users à des profiles via leurs attributs
profile_filename = join(LOCAL_DIR, 'perm', 'data', 'profiler.ini')

# Path vers le serveur de profile et l'interface d'admin
LOCATION = "/usr/share/xmlrpc-posh/"


# XMLRPC
xmlrpc = ConfigurationObject.get_xmlrpc_conf()
XMLRPC_PORT = int(xmlrpc.get('posh_xmlrpc_port', '7080'))
XMLRPC_IP_SERVER = xmlrpc.get('posh_xmlrpc_ip', 'localhost')
# Nom du gestionnaire de profil pour son auth auprès du serveur SSO
SERVICE_AUTH_NAME = xmlrpc.get('posh_profile_service_name',
                               'http://xmlrpc-posh/server')
LOCAL_IP = xmlrpc.get('adresse_log', '127.0.0.1')

ADMIN_PORT = int('7070')
AUTHFILE_PATH = "/usr/share/xmlrpc-posh/interface/interface/auth/"
# Timeout de la session de l'interface en 12 min si pas d'action
SESSION_TIMEOUT = 12 * 60

# Script de récupération des infos de la BDD Posh pour le client xmlrpc
INFO_FILE = join(SCRIPT_PATH, 'utils', "dbinfo.php")

db_pwd, db_host = ConfigurationObject.get_sql_pass()
profile_db_config = dict(host=db_host,
                         user='posh',
                         passwd=db_pwd,
                         db='poshprofile',
                         use_unicode=False,
                         charset='utf8')

posh_db_config = dict(host=db_host,
                      user='posh',
                      passwd=db_pwd,
                      db='posh',
                      use_unicode=False,
                      charset='utf8')

# configuration du serveur SSO
eolesso = ConfigurationObject.get_sso_conf()
ip_sso = eolesso.get('eolesso_adresse', 'localhost')
port_sso = eolesso.get('eolesso_port', 8443)
AUTH_FORM_URL = "https://%s:%s/" % (ip_sso, port_sso)
AUTH_SERVER = "https://%s:%s/xmlrpc" % (ip_sso, port_sso)

# Logs DU client xmlrpc et des outils qu'ils utilisent :
LOG_CLIENT = "/var/log/posh/client.log"

