#-*-coding:utf-8-*-
"""
   Requête SQL pour l'insertion dynamique d'onglet dans la base posh
"""
from os.path import join

# nom des champs de la table profile, les 4 premiers viennent des profils
# cacheurl=tag les onglets métiers (valeur=metier au lieu de unused)
# pass = stockage du 'name' de l'onglet dans le gestionnaire de profile
# user_id = id utilisateur
FIELDS = """pass name seq type param user_id cacheurl width height""".split()
MODULE_FIELDS = """item_id user_id profile_id posx posy posj x y typ \
variables uniq blocked minimized old_id feed_id shared currentview""".split()
FIELD_VALUES = ["%s=%%s" % field for field in FIELDS]
# id de l'utilisateur admin dans la base posh
ID_ADMIN = "1"

# syntaxe sql
# recupère l'user_id d'un user
USER_ID_QUERY = "SELECT id FROM users WHERE username=%s"
# recuperation des onglets de l'utililsateur
GETTAB_QUERY = "SELECT * FROM profile WHERE user_id=%s ORDER BY seq"
# recuperation des onglets métiers de l'utililsateur
GETSPECTAB_QUERY = "SELECT * FROM profile WHERE user_id=%s and \
cacheurl='metier' ORDER BY seq"
# recuperation de l'id d'un onglet dans la table profile
GETTABID_QUERY = "SELECT id FROM profile WHERE %s" % ' and '.join(FIELD_VALUES)
# recuperation des onglets dont le seq est supérieur à un seq donné
SELECT_SEQ_QUERY = "SELECT * FROM profile WHERE user_id=%s and seq>=%s \
ORDER BY seq"
# recuperation d'un id de la table profile posh
# depuis une entrée du gestionnaire de profil
GET_THUMBID = "SELECT id FROM profile WHERE user_id=%s and name=%s \
and cacheurl='metier'"
# GESTION DES WIDGETS (ou modules):
# de l'administrateur
ADMIN_THUMB_MODULES_QUERY = "SELECT * FROM module WHERE user_id=%s and \
profile_id=%%s" % ID_ADMIN
# récupération des modules écrits par ce programme
# et de ceux intercalés par l'utilisateur
USER_PROFILED_THUMB_MODULES_QUERY = "SELECT * FROM module WHERE user_id=%s \
and profile_id=%%s and typ='m'"
USER_PERSO_THUMB_MODULES_QUERY =  "SELECT * FROM module WHERE user_id=%s \
and profile_id=%%s and typ!='m'"


# insertion d'un élément
S_FORMAT = ['%s' for i in FIELDS]
INSERTTAB_QUERY = "INSERT INTO profile (%s) VALUES (%s)" % (
                                                    ','.join(FIELDS),
                                                    ','.join(S_FORMAT))
S_FORMAT = ['%s' for i in MODULE_FIELDS]
INSERTMODULE_QUERY = "INSERT INTO module (%s) VALUES (%s)" % (
                                                    ','.join(MODULE_FIELDS),
                                                    ','.join(S_FORMAT))

# mise à jour d'un onglet
# Insertion de modules dans une page
UPDATE_ID_MODULE = "UPDATE module SET uniq=%s WHERE user_id=%s and \
profile_id=%s and uniq=%s"
UPDATE_MODULE = "UPDATE module SET item_id=%s,variables=%s WHERE \
user_id=%s and profile_id=%s and uniq=%s"
UPDATETAB_QUERY = "UPDATE profile SET seq='%s' WHERE user_id=%s and id=%s \
and name=%s"

# description de la table profile
# (indice des valeurs lors de leur renvoi par un SELECT *)
PROFILE_TABLE_INDICES = {'id':0,
                         'user_id':1,
                         'name':2,
                         'eolename':9,
                         'seq':20,
                         '_type':24,
                         'param':25,
                        }
