#-*-coding:utf-8-*-
###########################################################################
# Eole NG - 2007
# Copyright Pole de Competence Eole  (Ministere Education - Academie Dijon)
# Licence CeCill  cf /root/LicenceEole.txt
# eole@ac-dijon.fr
#
# GESTIONNAIRE POUR LES TABLES DE JOINTURE
###########################################################################
"""
    Classe de gestion de table de jointure
    Une instance = Une table
"""
from posh.db.baseprofile import LinkDB

class LinkDBConstructor(LinkDB):
    """
        classe de gestion de table de jointure
        mytable = [{'name':nomdelapremièretable,
                    'idattr': nom du champ},
                   {'name':nomdeladeuxièmetable,
                    'idattr':'nom du champ id dans la deuxième table}
                   ]
        la table de jointure s'appelera :
        nomdelapremièretablenomdeladeuxièmetable
    """
    CREATE_TABLE = """CREATE TABLE IF NOT EXISTS `%s` (
                        `%s` MEDIUMINT NOT NULL,
                        `%s` MEDIUMINT NOT NULL
                      )ENGINE = MYISAM DEFAULT CHARSET=utf8 \
COLLATE=utf8_unicode_ci COMMENT='';"""
    ADDFIELD_QUERY = """INSERT into `%s` (%s) VALUES (%%s)"""
    FIELD_QUERY = """SELECT * FROM `%s` %%s """
    DELETE_QUERY = """DELETE FROM %s WHERE %%s """

    def __init__(self, dbinfos, mytable):
        self.table_name = "%s%s" % (mytable[0]['name'], mytable[1]['name'])
        self.FIELDS = [mytable[0]['idattr'], mytable[1]['idattr']]
        self.ADDFIELD_QUERY = self.ADDFIELD_QUERY % (self.table_name,
                                                ','.join(self.FIELDS))
        self.CREATE_TABLE = self.CREATE_TABLE % (self.table_name,
                                                 self.FIELDS[0],
                                                 self.FIELDS[1])
        self.FIELD_QUERY = self.FIELD_QUERY % self.table_name

        self.DELETE_QUERY = self.DELETE_QUERY % self.table_name
        self.table_libelle = "%s <=> %s" % (self.FIELDS[0], self.FIELDS[1])
        super(LinkDBConstructor, self).__init__(dbinfos)
