#-*-coding:utf-8-*-
"""
    Client xmlrpc gérant les encodages de données
"""
import xmlrpclib

# les 2 fonctions qui suivent ont été dupliquées
# depuis zephir.lib_zephir
CHARSET = 'UTF-8'

def convert(objet):
    """Transforme les objets unicode contenus dans un objet en chaines
    """
    if type(objet) == list:
        l = []
        for item in objet:
            l.append(convert(item))
        return l
    if type(objet) == dict:
        dico = {}
        for cle in objet.keys():
            dico[cle] = convert(objet[cle])
        return dico
    if type(objet) == unicode:
        string =  objet.encode(CHARSET)
        return string
    return objet

def u(objet):
    if type(objet) == list:
        l = []
        for item in objet:
            l.append(u(item))
        return l
    if type(objet) == dict:
        dico = {}
        for cle in objet.keys():
            dico[cle] = u(objet[cle])
        return dico
    if type(objet) == str:
        string = unicode(objet, CHARSET)
        return string
    return objet


class _M:
    # some magic to bind an XML-RPC method to an RPC server.
    # supports "nested" methods (e.g. examples.getStateName)
    def __init__(self, send, name):
        self.__send = send
        self.__name = name

    def __getattr__(self, name):
        return _M(self.__send, "%s.%s" % (self.__name, name))

    def __call__(self, *args):
        # un peu crade, ça mériterait de gérer les tuples dans u
        # ici, les éléments d'un tuple ne seront pas encodé
        args = tuple(u(list(args)))
        return convert(self.__send(self.__name, args))
xmlrpclib._Method = _M
