#-*-coding:utf-8-*-
"""
    Librairie de cryptage ssl pour l'interface posh-profile
"""
import xmlrpclib
from OpenSSL import SSL, crypto

# FIXME : mode conteneur
try:
    from creole.cert import cert_file, key_file
except:
    cert_file = '/etc/ssl/certs/eole.crt'
    key_file = '/etc/ssl/certs/eole.key'

class TransportEole(xmlrpclib.SafeTransport):
    """
        Librairie de transport d'information
    """
    def make_connection(self, host):
        """
            Construit la connexion
        """
        # create a HTTPS connection object from a host descriptor
        # host may be a string, or a (host, x509-dict) tuple
        import httplib
        localhost, extra_headers, x509 = self.get_host_info(host)
        try:
            HTTPS = httplib.HTTPS
        except AttributeError:
            raise NotImplementedError(
                "your version of httplib doesn't support HTTPS"
                )
        else:
            cx = HTTPS(localhost, None,
                       key_file = key_file,
                       cert_file = cert_file)
            return cx


class ServerContextFactory:
    """
        Factory permettant de créer un contexte SSL
    """

    def __init__(self):
        """
            load the key and cert files in a PKey Object
        """
        self.cert = crypto.load_certificate(crypto.FILETYPE_PEM,
                                          open(cert_file).read())
        self.key = crypto.load_privatekey(crypto.FILETYPE_PEM,
                                           open(key_file).read())

    def getContext(self):
        """
            Create an SSL context.
            Load cert and key files in a context
        """
        ctx = SSL.Context(SSL.SSLv23_METHOD)
        ctx.use_certificate(self.cert)
        ctx.use_privatekey(self.key)
        return ctx
