# -*- coding: utf-8 -*-
from nevow.rend import Fragment
from nevow import loaders
from os.path import join
from interface.interface.config import HTML_DIR
from interface.interface.tools import _get_root_url
from interface.interface.data_handler import datas
from interface.interface.frags.scrollmenu import ScrollMenuManager

def make_linkmenu_js(rooturl, name):
    """
        Renvoie le lien de l'item de menu permission
    """
    url = "?linkform=%s" % name
    return "javascript:callUrl('%s',[], 'content_container');" % (
                                              join(rooturl, url),)
def make_addmenu_js(rooturl, name):
    """
        Renvoie le lien de l'item de menu ajout
    """
    url = "?addform=%s" % name
    js_link = "javascript:callUrl('%s',[], 'popup_container');" % (
                                              join(rooturl, url),)
    return js_link + "window.scrollTo(0,0);"

def make_modmenu_js(rooturl, name):
    """
        Renvoie le lien de l'item de menu modification
    """
    url = "?listform=%s" % name
    js_link = "javascript:callUrl('%s',[], 'content_container');" % (
                                                 join(rooturl, url),)
    return js_link + "window.scrollTo(0,0);"

class Menu(Fragment):
    """
        menu d'entête de la page
    """
    docFactory = loaders.xmlfile(join(HTML_DIR, 'menu.xml'))

    def data_scroll_menu(self, ctx, data):
        """ renvoit les datas pour les constructions des fenêtres """

        # Ajout de lien
        LINKURL = join(_get_root_url(ctx), 'link')
        data = []
        entete1 = ['Permission', 'Gérer les autorisations']
        items1 = [[table['libelle'],
                   make_linkmenu_js(LINKURL, table['name']),
                   table['libelle']]for table in datas.link_menu()]
        menu1 = [entete1, items1]

        # Ajout
        ADDURL = join(_get_root_url(ctx), 'add')
        entete2 = ['Ajout de paramètres',
                   "Ajout de paramètre pour les permissions"]
        items2 = [[table['libelle'],
                    make_addmenu_js(ADDURL, table['name']),
                    table['libelle']]for table in datas.add_menu()]

        # items specifiques (non integrees dans la chaine bdd - interface)
        ICONURL = join(_get_root_url(ctx), 'icone')
        js_link = "javascript:callUrl('%s', [], 'content_container');" % ICONURL
        js_link += "window.scrollTo(0,0);"
        items2.append(['Télécharger une icône',
                       js_link,
                      "Télécharger une icône pour l'application desktop"])

        menu2 = [ entete2, items2]

        # Modification / Suppression
        LISTURL = join(_get_root_url(ctx), 'list')
        entete3 = ['Modification / Suppression',
                   'Supprimer ou modifier des éléments']
        items3 = [[table['libelle'],
                   make_modmenu_js(LISTURL, table['name']),
                   table['libelle']]for table in datas.add_menu()]
        menu3 = [entete3, items3]
        data = [menu1, menu2, menu3]
        return data

    def render_scroll_menu(self, ctx, data):
        mm = ScrollMenuManager(width=180,
                               height=35,
                               top=2,
                               left=15,
                               scrollable=True)
        for menu in data:
            mm.add_menu(menu)
        return mm.render()
