# -*- coding: utf-8 -*-
from os.path import join
from nevow.rend import Page
from nevow import loaders, tags as T
from interface.interface.config import HTML_DIR

class Message(Page):
    docFactory = loaders.xmlfile(join(HTML_DIR, 'message.xml'))
    close_btn_code = "setContent('nomdelabalisequicontientlemessage', '')";

    def data_message(self, ctx, data):
        return self.message

    def render_message(self, ctx, datas):
        if isinstance(datas, dict):
            body_tag = T.div(_class="message%s_box" % datas.get('alert', ''))
            for msg in datas['message']:
                tag = ""
                if isinstance(msg, dict):
                    font = msg.get('font', '')
                    _class = "message_%s" % font
                    libelle = msg['libelle']
                    if msg.get('tab', 0):
                        ddtag = T.dd(_class=_class)[libelle]
                        tag = T.dl()[ddtag]
                        for i in  range(msg.get('tab', 0)-1):
                            tag = T.dl()[T.dd()[tag]]
                        body_tag.children.append(tag)
                    else:
                        spantag = T.span(_class=_class)[libelle]
                        body_tag.children.append(spantag)
                        body_tag.children.append(T.br())
                elif isinstance(msg, str):
                    body_tag.children.append(msg)
                else:
                    raise Exception, "Erreur de type dans Message-data_message"
        else:
            body_tag = T.div(_class="message_box")[datas]
        header_tag = T.div(_class="message_box_header")[self.make_close_btn()]
        innerdiv = T.div(_class="message_box_inner")[header_tag, body_tag]
        return T.div(_class="message_box_container")[innerdiv]

    def make_close_btn(self):
        return T.a(href="javascript:%s" % self.close_btn_code)[
                                          "Fermer",
                                          T.img(src="/image/close.gif")]
